stages:
  - setup
  - core
  - scaffold

image: node:latest

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .npm/
  policy: pull

npm:prepare:
  stage: setup
  script:
    - npm ci --cache .npm --prefer-offline
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .npm/
    policy: pull-push
  artifacts:
    paths:
      - node_modules/
      - scaffold/web/node_modules/

core:verify:
  stage: core
  needs:
    - npm:prepare
  script:
    - ci/core_verify.sh

core:build:
  stage: core
  needs:
    - npm:prepare
  script:
    - ci/core_build.sh
  artifacts:
    paths:
      - packages/core/*/dist
      - packages/util/dist
      - packages/games/*/dist
      - packages/games/_collections/*/dist

scaffold:verify:
  stage: scaffold
  needs:
    - npm:prepare
    - core:build
  script:
    - cd scaffold/server
    - npm run verify:ci
    - cd ../web
    - npm run verify:ci
